<h1>Accounts</h1>
<div class="row mb-3">
  <div class="col">
    <a [routerLink]="['/accounts/new']" nbButton status="primary">NEW</a>
  </div>
</div>

<table mat-table [dataSource]="dataSource" matSort matSortActive="username" matSortDirection="asc">
  <tr mat-header-row *matHeaderRowDef="columnsToDisplay" class="first-header-row"></tr>
  <tr mat-header-row *matHeaderRowDef="filterRow" class="second-header-row"></tr>
  <tr mat-row *matRowDef="let row; columns: columnsToDisplay"></tr>

  <ng-container matColumnDef="id-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 350px"></th>
  </ng-container>

  <ng-container matColumnDef="username-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 300px">
      <mat-form-field class="filter" floatLabel="never">
        <mat-label>Search</mat-label>
        <input matInput [formControl]="nameFilterValue">
      </mat-form-field>
    </th>
  </ng-container>

  <ng-container matColumnDef="cardId-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 200px">
      <mat-form-field class="filter" floatLabel="never">
        <mat-label>Search</mat-label>
        <input matInput [formControl]="cardIdFilterValue">
      </mat-form-field>
    </th>
  </ng-container>

  <ng-container matColumnDef="roles-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 300px"></th>
  </ng-container>

  <ng-container matColumnDef="balance-filter">
    <th mat-header-cell *matHeaderCellDef>
      <mat-form-field class="filter" floatLabel="never">
        <mat-label>Search</mat-label>
        <input type="number" matInput [formControl]="balanceFilterValue">
      </mat-form-field>
    </th>
  </ng-container>

  <ng-container matColumnDef="overdraft-filter">
    <th mat-header-cell *matHeaderCellDef>
      <mat-form-field class="filter" floatLabel="never">
        <mat-label>Search</mat-label>
        <input type="number" matInput [formControl]="overdraftFilterValue">
      </mat-form-field>
    </th>
  </ng-container>

  <ng-container matColumnDef="locked-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 50px"></th>
  </ng-container>

  <ng-container matColumnDef="actions-filter">
    <th mat-header-cell *matHeaderCellDef></th>
  </ng-container>

  <ng-container matColumnDef="id">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>ID</th>
    <td mat-cell *matCellDef="let acc">{{acc.id || '-'}}</td>
  </ng-container>

  <ng-container matColumnDef="username">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>User</th>
    <td mat-cell *matCellDef="let acc">{{acc.username || '-'}}</td>
  </ng-container>

  <ng-container matColumnDef="cardId">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>Card ID</th>
    <td mat-cell *matCellDef="let acc">{{acc.cardId || '-'}}</td>
  </ng-container>

  <ng-container matColumnDef="roles">
    <th mat-header-cell *matHeaderCellDef>Roles</th>
    <td mat-cell *matCellDef="let acc">{{acc.roles | concatRoles }}</td>
  </ng-container>

  <ng-container matColumnDef="balance">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>Balance</th>
    <td mat-cell *matCellDef="let acc">{{acc.balance | currency}}</td>
  </ng-container>

  <ng-container matColumnDef="overdraft">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>Overdraft facility</th>
    <td mat-cell *matCellDef="let acc">{{acc.overdraft | currency}}</td>
  </ng-container>

  <ng-container matColumnDef="locked">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>Locked</th>
    <td mat-cell *matCellDef="let acc">
      <nb-checkbox [checked]="acc.locked" [status]="acc.locked ? 'danger':'success'" disabled></nb-checkbox>
    </td>
  </ng-container>

  <ng-container matColumnDef="actions">
    <th mat-header-cell *matHeaderCellDef>Actions</th>
    <td mat-cell *matCellDef="let acc">
      <a nbButton ghost size="large" [routerLink]="['/accounts', acc.id]" title="Edit">
        <nb-icon icon="edit"></nb-icon>
      </a>
      <button nbButton ghost size="large" (click)="delete(acc)" title="Delete">
        <nb-icon icon="trash"></nb-icon>
      </button>
    </td>
  </ng-container>

</table>
<mat-paginator [length]="dataSource.totalCount" [pageSize]="dataSource.pageSize"
               [pageSizeOptions]="[5, 10, 20, 50]" showFirstLastButtons></mat-paginator>
